--memperbaiki bug saat tidak ada koneksi internet
require "import"
import "android.content.Context"
import "android.content.Intent"
import "java.util.Locale"

import "android.speech.SpeechRecognizer"
import "android.speech.RecognitionListener"
import "android.speech.RecognizerIntent"
import "java.util.Locale"
import "android.content.Intent"

local substitutionTable = {
["ambo"] = "ambo,",
["aden"] = "aden,",
["awak"] = "awak,",
["abak"] = "abak,",
["Abi"] = "Abi,",
["abu"] = "abu,",
["ancak"] = "ancak,",
["agak"] = "agak,",
["agia"] = "agia,",
["ado"] = "ado,",
["ajo"] = "ajo,",
["ako"] = "ako,",
["alai"] = "alai,",
["ama"] = "ama,",
["anta"] = "anta,",
["ang"] = "ang,",
["ala"] = "ala,",
["apo"] = "apo,",
["ayai"] = "ayai,",
["adiak"] = "adiak,",
["asoi"] = "asoi,",
["amuah"] = "amuah,",
["banyak"] = "banyak,",
["banaman"] = "banaman,",
["lansuang"] = "lansuang,",

}

function capitalizeFirstWord(text)
local firstChar = text:sub(1, 1)
local restOfString = text:sub(2)
return firstChar:upper() .. restOfString
end

function substituteWords(text)
for word, substitution in pairs(substitutionTable) do
text = text:gsub("%f[%a]" .. word .. "%f[%A]", substitution)
end
return text
end

function capitalizeAfterPeriod(text)
return text:gsub("(%.[%s%p]*%a)", function(match)
local char = match:sub(-1)
local capitalizedChar = char:upper()
return match:sub(1, -2) .. capitalizedChar
end)
end

function addPunctuation(text)
local lastChar = text:sub(-1)
local punctuation = { ".", "!", "?" }
local hasPunctuation = false

for _, p in ipairs(punctuation) do
if lastChar == p then
hasPunctuation = true
break
end
end

if not hasPunctuation then
text = text .. "."
end

return text
end
function hasInternetConnection()
local connectivityManager = this.getSystemService(Context.CONNECTIVITY_SERVICE)
local networkInfo = connectivityManager.getActiveNetworkInfo()
return networkInfo ~= nil and networkInfo.isConnected()
end

function kill()
speechRecognizer.destroy()
speechRecognizer = nil
return true
end

function startListening()
if not hasInternetConnection() then
-- No hay conexión a Internet, no se puede realizar el reconocimiento de voz
service.asyncSpeak("No hay conexión a Internet. El reconocimiento de voz no está disponible.")
return false
end

speechRecognizer = SpeechRecognizer.createSpeechRecognizer(this)
speechListener = RecognitionListener{
onResults = function(results)
data = results.getParcelableArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
if data ~= nil and data.size() > 0 then
local recognizedText = data.get(0)
recognizedText = capitalizeFirstWord(recognizedText)
recognizedText = substituteWords(recognizedText)
recognizedText = capitalizeAfterPeriod(recognizedText)
recognizedText = addPunctuation(recognizedText)
service.paste(recognizedText .. "\n")
service.speak(recognizedText)
end
kill()
end,
onError = function()
kill()
startListening()
end
}

recognizerIntent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, Locale.getDefault())
recognizerIntent.putExtra(RecognizerIntent.EXTRA_CALLING_PACKAGE, this.getPackageName())
speechRecognizer.startListening(recognizerIntent)
speechRecognizer.setRecognitionListener(speechListener)

return true
end

startListening()